import { ValidationContext } from '@common/forms/validation/validation-context';
import { FormGroup, FormBuilder, Validators } from '@angular/forms';
import { BackendErrorValidator } from '@common/forms/validation/custom-validator';

export class ExtraPropertiesFormModel {
	public language: string;

	fromModel(item: any): ExtraPropertiesFormModel {
		this.language = item.language;
		return this;
	}

	buildForm(context: ValidationContext = null, disabled: boolean = false): FormGroup {
		if (context == null) { context = this.createValidationContext(); }

		const formGroup = new FormBuilder().group({
			language: [{ value: this.language, disabled: disabled }, context.getValidation('language').validators]
		});
		return formGroup;
	}

	createValidationContext(): ValidationContext {
		const baseContext: ValidationContext = new ValidationContext();
		baseContext.validation.push({ key: 'language', validators: [] });
		return baseContext;
	}

}
